var Language = {
    en: {
        langName: "English",
        title: "Japanese language morphological Analyses",
        frontHeader: "JLM Analyses",
        input: "Type Japanese sentences",
        resultHeader: "Result",
        submit: "Check",
        surface: "Surface",
        reading: "Reading",
        wordClass: "Class",
        baseform: "Root",
        xhrError: "HTTP Error",
        xhrCompleted: "Check completed.",
        xhrError400: "Bad Request - Some parameters are invalid.",
        xhrError403: "Forbidden - Over the limit of the day.",
        xhrError404: "Not Found - Server down, and so on.",
        xhrError503: "Service unavailable - Service cannnot response.",
        noSentence: "You haven't type Japanese yet.",
        sameWordWasChecked: "Same sentence has checked. Using previous result.",
        adjective: "adjective",
        naAdjective: "na-adjective",
        interjection: "interjection",
        adverb: "adverb",
        adnominal: "adnominal",
        conjunction: "conjunction",
        prefix: "prefix",
        suffix: "suffix",
        noun: "noun",
        verb: "verb",
        particle: "particle",
        auxiliaryVerb: "auxiliary verb",
        special: "special",
        specialExample: "(period, comma, symbols, etc.)",
        unknownClass: "unknown class",
        preference: "Preferences",
        general: "General",
        language: "Language",
        change: "Change",
        details: "Details",
        zoom: "Zoom",
        about: "About this widgets",
        name: "Name",
        author: "Author",
        version: "Version",
        relativePage: "Relative pages",
        authorSite: "Author's website (Japanese)",
        downloadPage: "Download page (Japanese)",
        preferencesUpdated: "Preferences are updated.",
        nowChecking: "Now checking. Wait a moment..."
      },
    ja: {
        langName: "日本語",
        title: "日本語形態素解析",
        frontHeader: "日本語形態素解析",
        input: "調べる文章を入力してください",
        resultHeader: "結果",
        submit: "調べる",
        surface: "表記",
        reading: "読み仮名",
        wordClass: "品詞",
        baseform: "基本形",
        xhrError: "HTTPエラー",
        xhrCompleted: "調べ終わりました。",
        xhrError400: "不正なリクエストです。",
        xhrError403: "同一IPからのアクセスは一日50000件に制限されています。",
        xhrError404: "サーバが見つかりません。",
        xhrError503: "サービスにエラーが生じています。しばらく経ってからもう一度お試しください。",
        noSentence: "検索語が未入力です。",
        sameWordWasChecked: "同じ文章が検索されたため以前の結果を利用しました。",
        adjective: "形容詞",
        naAdjective: "形容動詞",
        interjection: "感動詞",
        adverb: "副詞",
        adnominal: "連体詞",
        conjunction: "接続詞",
        prefix: "接頭辞",
        suffix: "接尾辞",
        noun: "名詞",
        verb: "動詞",
        particle: "助詞",
        auxiliaryVerb: "助動詞",
        special: "特殊",
        specialExample: "（句読点、カッコ、記号など）",
        unknownClass: "未知の品詞",
        preference: "設定",
        general: "全般",
        language: "言語",
        change: "変更する",
        details: "詳細",
        zoom: "拡大",
        about: "このウィジェットについて",
        name: "名前",
        author: "作成者",
        version: "バージョン",
        relativePage: "関連ページ",
        authorSite: "作成者のWebサイト",
        downloadPage: "ダウンロードページ",
        preferencesUpdated: "設定変更が完了しました。",
        nowChecking: "問い合わせ中です。しばらくお待ちください……"
     },
     hepburn: {
        langName: "Romaji (Hephurn)",
        title: "Nihongo keitaiso kaiseki",
        frontHeader: "Nihongo keitaiso kaiseki",
        input: "Shiraberu bunsho wo nyuryoku shite kudasai",
        resultHeader: "Kekka",
        submit: "Shiraberu",
        surface: "Hyoki",
        reading: "Yomigana",
        wordClass: "Hinshi",
        baseform: "Kihon kei",
        xhrError: "HTTP error",
        xhrCompleted: "Shirabe owari mashita.",
        xhrError400: "Fuseina rikuesuto desu.",
        xhrError403: "Douitsu IP karano akusesu wa ichinichi 50000 kenni seigen sarete imasu.",
        xhrError404: "server ga mitsukari masen.",
        xhrError503: "service ni error ga shojite imasu. Shibaraku tatte kara mouichido otameshi kudasai.",
        noSentence: "Kensakugo ga minyuryoku desu.",
        sameWordWasChecked: "Onaji bunshou ga kensaku sareta tame izen no kekka wo riyou shimashita.",
        adjective: "Keiyo-shi",
        naAdjective: "Keiyo do-shi",
        interjection: "Kando-shi",
        adverb: "Fuku-shi",
        adnominal: "Rentai-shi",
        conjunction: "Setsuzoku-shi",
        prefix: "Setto-ji",
        suffix: "Setsubi-ji",
        noun: "Mei-shi",
        verb: "Do-shi",
        particle: "Jo-shi",
        auxiliaryVerb: "Jo do-shi",
        special: "Tokushu",
        specialExample: "(Kuto-ten, Kakko, Kigo nado)",
        unknownClass: "Michi no hin-shi",
        preference: "Settei",
        general: "Zenpan",
        language: "Gengo",
        change: "Henkou suru",
        details: "Shousai",
        zoom: "Kakudai",
        about: "Kono widgets ni tsuite",
        name: "Namae",
        author: "Sakusei-sha",
        version: "Version",
        relativePage: "Kanren page",
        authorSite: "Sakusei-sha no website (Nihon-go)",
        downloadPage: "Download page (Nihon-go)",
        preferencesUpdated: "Settei henkou ga kanryo shimashita.",
        nowChecking: "Toiawasechu desu. Shibaraku omachi kudasai..."
     }

};
