// http://developer.yahoo.co.jp/jlp/MAService/V1/parse.html
var version = "1.1";
var $id = function(id) { return window.document.getElementById(id); };
var $atxt = function(node, text) { return deleteChilds(node).appendChild(window.document.createTextNode(text)); };
var checked = {};
var doc = window.document;
var modaling = false;
var User = {};

function about() {
    if ((window.event.keyCode != 13 && window.event.button != 0) || modaling) return false;
    modaling = true;
    $id("aboutView").style.display = "block";
    showModalView();
};

function addShadowText(parent, text, width, height) {
    var svg = makeShadowImage(text, width, height);
    var obj = document.createElement("object");
    obj.setAttribute("height", height);
    obj.setAttribute("width", width);
    obj.setAttribute("type", "image/svg+xml");
    obj.setAttribute("data", svg);
    obj.appendChild(document.createTextNode(text));
    parent.appendChild(obj);
};

function check() {
    if (window.event.keyCode != 13 && window.event.button != 0) return false;
    checkButtonStatus(false);
    var sentence = $id("input").value;
    var box = $id("messageFooter");
    if (box.hasChildNodes()) box.removeChild(box.firstChild);
    if (sentence == User.lang.input) {
        message(User.lang.noSentence);
    } else if (typeof(checked[sentence]) == 'undefined') {
        request(sentence);
    } else {
        message(User.lang.sameWordWasChecked);
        showResult(sentence, checked[sentence]);
    }
    checkButtonStatus(true);
};

function checkButtonStatus(status) {
    var button = $id("submit");
    if (status) {
        button.disabled = false;
        button.style.opacity = 1;
    } else {
        button.disabled = true;
        button.style.opacity = .5;
    }
};

function config() {
    if ((window.event.keyCode != 13 && window.event.button != 0) || modaling) return false;
    modaling = true;
    showConfig("prefGeneral");
    showModalView();
};

function deleteChilds(node) {
    var n = node.childNodes.length;
    for (var i = 0; i < n; i++) {
        node.removeChild(node.firstChild);
    }
    return node;
};

function init() {
    var navigatorLang = navigator.language.substring(0, 2).toLowerCase();
    if (widget.preferenceForKey("lang").length > 1) {
        User.lang = Language[widget.preferenceForKey("lang")];
    } else if (typeof(Language[navigatorLang]) != 'undefined') {
        User.lang = Language[navigatorLang];
        widget.setPreferenceForKey(navigatorLang, "lang");
    } else {
        User.lang = Language["en"];
        widget.setPreferenceForKey("en", "lang");
    }
    User.filter = [true,true,true,true,true,true,true,true,true,true,true,true,true];
    setTexts();
    var buttons = {
        submit: check,
        quitButton: quit,
        configButton: config,
        modalCloseButton: modalClose,
        aboutButton: about,
        prefGeneralSubmit: prefGeneralUpload
    };
    for (var x in buttons) {
        var button = $id(x);
        button.addEventListener("click", buttons[x], false);
        button.addEventListener("keypress", buttons[x], false);
    }
};

function makeShadowImage(str, width, height) {
    var svg = ['<?xml version="1.0" encoding="utf-8"?>',"\n",
               '<svg xmlns="http://www.w3.org/2000/svg" width="',width,'px" height="',height,'px">',
                '<defs>',
                 '<filter id="shadow">',
                  '<feGaussianBlur in="SourceAlpha" stdDeviation="1" result="blur"/>',
                  '<feOffset in="blur" dx="2" dy="2" result="offsetBlur"/>',
                  '<feMerge>',
                   '<feMergeNode in="offsetBlur"/>',
                   '<feMergeNode in="SourceGraphic"/>',
                  '</feMerge>',
                 '</filter>',
                '</defs>',
                '<text id="frontHeaderText" x="0" y="14px" font-size="16px" filter="url(#shadow)" text-anchor="start" style="font-weight:bold" fill="#ffffff">',
                str,
                '</text>',
               '</svg>'];
    var data = ['data:image/svg+xml,', escape(svg.join("")).replace(/%u\w\w\w\w/g, (function(s){return unescape(s)}))].join("");
    return data;
};

function message(msg) {
    var footer = $id("messageFooter");
    deleteChilds(footer);
    $atxt(footer, msg);
};

function modalClose() {
    if ((window.event.keyCode == 13 || window.event.button == 0) && modaling) {
        $id("modalView").style.display = "none";
        var views = document.evaluate('id("modalView")/div', document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        try {
            var view;
            while (view = views.iterateNext()) {
                view.style.display = "none";
            }
        } catch (e) {
        }
        modaling = false;
    }
    message("");
};

function posTextToClassName(string) {
    switch (string) {
      case "形容詞":
        return User.lang.adjective;
        break;
      case "形容動詞":
        return User.lang.naAdjective;
        break;
      case "感動詞":
        return User.lang.interjection;
        break;
      case "副詞":
        return User.lang.adverb;
        break;
      case "連体詞":
        return User.lang.adnominal;
        break;
      case "接続詞":
        return User.lang.conjunction;
        break;
      case "接頭辞":
        return User.lang.prefix;
        break;
      case "接尾辞":
        return User.lang.suffix;
        break;
      case "名詞":
        return User.lang.noun;
        break;
      case "動詞":
        return User.lang.verb;
        break;
      case "助詞":
        return User.lang.particle;
        break;
      case "助動詞":
        return User.lang.auxiliaryVerb;
        break;
      case "特殊":
        return User.lang.special;
        break;
      default:
        return User.lang.unknownClass;
        break;
    }
};

function prefGeneralUpload() {
    var lang = $id("langSelect").value;
    widget.setPreferenceForKey(lang, "lang");
    User.lang = Language[lang];
    setTexts();
    message(User.lang.preferencesUpdated);
};

function quit() {
    if ((window.event.keyCode == 13 || window.event.button == 0) && !modaling) window.close();
};

function request(sentence) {
    message(User.lang.nowChecking);
    var userFilter = User.filter;
    var filter = new Array();
    for (var i = 0; i < 14; i++) {
        if (userFilter[i]) filter.push(i+1);
    }
    var post = {
        "appid": "OperaMorphologicAnalysWidgets",
        "sentence": sentence,
        "results": "ma",
        "response": "surface,reading,pos,baseform",
        "filter": filter.join("|")
      };
    var postArray = new Array();
    for (var key in post) {
        postArray.push(key + "=" + encodeURIComponent(post[key]));
    }
    var postStr = postArray.join("&");
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4) {
            if (xhr.status == 200) {
                result(sentence, xhr.responseXML);
            }
            xhrCompleted(xhr.status);
        }
    };
    xhr.open("POST", "http://api.jlp.yahoo.co.jp/MAService/V1/parse", true);
    xhr.setRequestHeader("Content-Type" , "application/x-www-form-urlencoded");
    xhr.send(postStr);
};

function result(sentence, xml) {
    checked[sentence] = xml;
    showResult(sentence, xml);
};

function setLanguageOptions() {
    var select = $id("langSelect");
    deleteChilds(select);
    var lang = widget.preferenceForKey("lang");
    for (var name in Language) {
        var option = document.createElement("option");
        option.value = name;
        $atxt(option, Language[name]["langName"]);
        if (lang == name) option.setAttribute("selected", "selected");
        select.appendChild(option);
    }
};

function setTexts() {
//    $atxt($id("frontHeader"), User.lang.frontHeader);
    var frontHeader = $id("frontHeader");
    addShadowText(deleteChilds(frontHeader), User.lang.frontHeader, 268, 24);
    var inputNd = $id("input");
    inputNd.onfocus = "if (this.value == '" + User.lang.input + "') this.value = '';";
    inputNd.onblur = "if (this.value == '') this.value = '" + User.lang.input + "';";
    inputNd.value = User.lang.input;
    var langs = ["submit", "resultHeader", "surface", "reading", "wordClass", "baseform", "zoom", "relativePage", "authorSite", "downloadPage"];
    var n = langs.length;
    for (var i = 0; i < n; i++) {
        $atxt($id(langs[i]), User.lang[langs[i]]);
    }
    $atxt($id("configHeader"), User.lang.preference);
    $atxt($id("prefGeneral"), User.lang.general);
    $atxt($id("prefGeneralHeader"), User.lang.general);
    $atxt($id("prefLanguage"), User.lang.language);
    setLanguageOptions();
    $atxt($id("prefGeneralSubmit"), User.lang.change);
    $atxt($id("detailsHeader"), User.lang.details);
    $atxt($id("zoomHeader"), User.lang.zoom);
    $atxt($id("aboutHeader"), User.lang.about);
    $atxt($id("widgetsNameHeader"), User.lang.name);
    $atxt($id("widgetsName"), User.lang.title);
    $atxt($id("authorHeader"), User.lang.author);
    $atxt($id("versionHeader"), User.lang.version);
    $atxt($id("version"), version);
    var title = document.evaluate('//title', document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
    deleteChilds(title.singleNodeValue);// Hack to allow <title> at least on Windows ;-)
    $atxt(title.singleNodeValue, User.lang.title);
};

function showConfig(id) {
    $id("configView").style.display = "block";
    var views = document.evaluate('id("configView")/div', document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
    try {
        var view;
        while (view = views.iterateNext()) {
            view.style.display = "none";
        }
    } catch (e) {
    }
    var menuItems = document.evaluate('id("configView")/ul[@class = "tabs"]/li', document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
    try {
        var item;
        while (item = menuItems.iterateNext()) {
            item.style.opacity = "0.6";
        }
    } catch (e) {
    }
    $id(id).style.opacity = "1";
    $id([id, "View"].join("")).style.display = "block";
};

function showModalView() {
    var modal = $id("modalView");
    modal.style.display = "block";
};

function showResult(sentence, xml) {
    var tbodyNd = $id("resultTableBody");
    deleteChilds(tbodyNd);
    var words = xml.evaluate('//jlp:ma_result/jlp:word_list/jlp:word', xml, (function(){return 'urn:yahoo:jp:jlp'}), XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
    var word;
    while (word = words.iterateNext()) {
        var result = [
            word.getElementsByTagName("surface")[0].textContent,
            word.getElementsByTagName("reading")[0].textContent,
            posTextToClassName(word.getElementsByTagName("pos")[0].textContent),
            word.getElementsByTagName("baseform")[0].textContent
            ];
        var trNd = window.document.createElement("tr");
        for (var i = 0; i < 4; i++) {
            var tdNd = window.document.createElement("td");
            $atxt(tdNd, result[i]);
            trNd.appendChild(tdNd);
        }
        tbodyNd.appendChild(trNd);
    }
};

function xhrCompleted(status) {
    var comment;
    var error = true;
    switch (status) {
      case 200:
        error = false;
        comment = User.lang.xhrCompleted;
        break;
      case 400:
        comment = User.lang.xhrError400;
        break;
      case 403:
        comment = User.lang.xhrError403;
        break;
      case 404:
        comment = User.lang.xhrError404;
        break;
      case 503:
        comment = User.lang.xhrError503;
        break;
    }
    if (error) comment = [ User.lang.xhrError, "(", status, ")", comment ].join("");
    message(comment);
};

